## python-awkward 2.6.5

=== awkward-cpp/CMakeLists.txt ===
# BSD 3-Clause License; see https://github.com/scikit-hep/awkward-1.0/blob/main/LICENSE

cmake_minimum_required(VERSION 3.15...3.26)

# Project must be near the top
project(
  ${SKBUILD_PROJECT_NAME}
  LANGUAGES CXX
  VERSION ${SKBUILD_PROJECT_VERSION})

message(STATUS "CMake version ${CMAKE_VERSION}")
message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

# Check for header-only libraries
if(NOT (EXISTS "header-only" AND EXISTS "include/awkward/kernels.h"))
  message(
    FATAL_ERROR
      "\
awkward-cpp relies upon generated and copied artefacts such as the header-only libraries and generated kernel headers. \
These could not be found, which indicates that\n\n\
    nox -s prepare\
\n\nwas skipped or failed. \
Please check https://github.com/scikit-hep/awkward#installation-for-developers to learn more about this process.\
")
endif()

# Setup the RPATH for built libraries
set(CMAKE_BUILD_RPATH_USE_ORIGIN TRUE)
if(APPLE)
  set(CMAKE_INSTALL_RPATH "@loader_path")
else()
  set(CMAKE_INSTALL_RPATH "\$ORIGIN")
endif()

# Three tiers: [cpu-kernels (extern "C" interface), cuda-kernels (extern "C" interface)],
# libawkward (C++), and Python modules.
file(GLOB CPU_KERNEL_SOURCES CONFIGURE_DEPENDS "src/cpu-kernels/*.cpp")
file(GLOB_RECURSE LIBAWKWARD_SOURCES CONFIGURE_DEPENDS "src/libawkward/*.cpp")

# Shared properties
add_library(awkward-parent INTERFACE)
target_compile_definitions(awkward-parent INTERFACE VERSION_INFO="${SKBUILD_PROJECT_VERSION}")
target_include_directories(awkward-parent INTERFACE include)
target_compile_features(awkward-parent INTERFACE cxx_std_17)

# C++ dependencies (header-only): RapidJSON
target_include_directories(awkward-parent INTERFACE rapidjson/include)

# C++ dependencies (header-only): GrowableBuffer
add_subdirectory(header-only EXCLUDE_FROM_ALL)
target_link_libraries(awkward-parent INTERFACE awkward::growable-buffer)

# First tier: cpu-kernels
add_library(awkward-cpu-kernels SHARED ${CPU_KERNEL_SOURCES})
target_link_libraries(awkward-cpu-kernels PUBLIC awkward-parent)
set_target_properties(
  awkward-cpu-kernels
  PROPERTIES CXX_VISIBILITY_PRESET hidden
             VISIBILITY_INLINES_HIDDEN ON
             CXX_EXTENSIONS NO)

# Second tier: libawkward
add_library(awkward SHARED ${LIBAWKWARD_SOURCES})
if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
  # Avoid emitting vtables in the dependent libraries
  target_compile_options(
    awkward
    PRIVATE -Werror=weak-vtables
            -Wweak-vtables
            -Wshorten-64-to-32
            -Wsign-compare
            -Wsign-conversion
            -Wshift-sign-overflow
            -Wreorder
            -Wrange-loop-analysis
            -Wconversion
            -Wunused)
endif()
target_link_libraries(awkward PUBLIC awkward-parent)
set_target_properties(
  awkward
  PROPERTIES CXX_VISIBILITY_PRESET hidden
             VISIBILITY_INLINES_HIDDEN ON
             CXX_EXTENSIONS NO)

# Third tier: Python modules.
find_package(Python REQUIRED COMPONENTS Interpreter Development.Module)
find_package(pybind11 CONFIG REQUIRED)

# Install python bindings
file(GLOB LAYOUT_SOURCES "src/python/*.cpp")
pybind11_add_module(_ext MODULE ${LAYOUT_SOURCES})
target_link_libraries(_ext PRIVATE awkward)
set_target_properties(
  _ext
  PROPERTIES CXX_VISIBILITY_PRESET hidden
             VISIBILITY_INLINES_HIDDEN ON
             CXX_EXTENSIONS NO)

# Install pure-python files
file(GLOB_RECURSE PYTHON_SOURCES "src/${SKBUILD_PROJECT_NAME}/*.py")

install(
  TARGETS awkward awkward-parent awkward-cpu-kernels _ext
  LIBRARY DESTINATION "${SKBUILD_PROJECT_NAME}/lib"
  RUNTIME DESTINATION "${SKBUILD_PROJECT_NAME}/lib"
  ARCHIVE DESTINATION "${SKBUILD_PROJECT_NAME}/lib")

install(FILES ${PYTHON_SOURCES} DESTINATION ${SKBUILD_PROJECT_NAME})

=== debian/changelog ===
python-awkward (2.6.5-1) unstable; urgency=medium

  [ Athos Ribeiro ]
  * Team upload.
  * d/p/no-internet.patch: do not download from PyPI (Closes: #1072109)
  * d/rules: use system packages for nox runs
  * d/control:
    - add missing python3-yaml B-D
    - B-D on python-is-python3. This ensures nox will find the correct python3
      binary file for its unconfined run during the package build.

  [ Andreas Tille ]
  * Standards-Version: 4.7.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 06 Jun 2024 16:07:33 +0200

python-awkward (2.6.1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Initial release (Closes: #1064291)

 -- Sascha Steinbiss <satta@debian.org>  Mon, 19 Feb 2024 18:28:57 +0100

=== debian/control ===
Source: python-awkward
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sascha Steinbiss <satta@debian.org>
Section: python
Priority: optional
Build-Depends: dh-sequence-python3,
               python3-setuptools,
               debhelper-compat (= 13),
               pybuild-plugin-pyproject,
               python3-hatchling,
               python3-hatch-fancy-pypi-readme,
               python3-all,
               python3-fsspec,
               python3-typing-extensions,
               python3-numpy,
               python3-pytest,
               python3-scikit-build-core,
               python3-pyproject-metadata,
               python3-yaml,
               python-is-python3,
               cmake,
               libpython3-all-dev,
               pybind11-dev,
               rapidjson-dev,
               nox
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/python-awkward
Vcs-Git: https://salsa.debian.org/med-team/python-awkward.git
Homepage: https://github.com/scikit-hep/awkward
Rules-Requires-Root: no

Package: python3-awkward
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Description: manipulate JSON-like data with NumPy-like idioms
 Awkward Array is a library for nested, variable-sized data, including
 arbitrary-length lists, records, mixed types, and missing data, using
 NumPy-like idioms.
 .
 Arrays are dynamically typed, but operations on them are compiled and fast.
 Their behavior coincides with NumPy when array dimensions are regular and
 generalizes when they're not.

## python-awkward 2.8.9

=== awkward-cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,11 @@
 # BSD 3-Clause License; see https://github.com/scikit-hep/awkward-1.0/blob/main/LICENSE
 
-cmake_minimum_required(VERSION 3.15...3.26)
+cmake_minimum_required(VERSION 3.15...3.30)
+
+if(NOT DEFINED SKBUILD)
+  set(SKBUILD_PROJECT_NAME awkward_cpp)
+  set(SKBUILD_PROJECT_VERSION 0.0.0)
+endif()
 
 # Project must be near the top
 project(
@@ -10,6 +15,14 @@
 
 message(STATUS "CMake version ${CMAKE_VERSION}")
 message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
+
+if(CMAKE_CXX_COMPILER_ID MATCHES AppleClang AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL
+                                                15)
+  if(CMAKE_VERSION VERSION_LESS 3.29)
+    message(WARNING "CMake should be 3.29+ to support AppleClang 15+. Trying anyway.")
+  endif()
+  set(CMAKE_LINKER_TYPE APPLE_CLASSIC)
+endif()
 
 # Check for header-only libraries
 if(NOT (EXISTS "header-only" AND EXISTS "include/awkward/kernels.h"))
@@ -25,12 +38,12 @@
 endif()
 
 # Setup the RPATH for built libraries
-set(CMAKE_BUILD_RPATH_USE_ORIGIN TRUE)
 if(APPLE)
   set(CMAKE_INSTALL_RPATH "@loader_path")
 else()
   set(CMAKE_INSTALL_RPATH "\$ORIGIN")
 endif()
+set(CMAKE_BUILD_RPATH_USE_ORIGIN TRUE)
 
 # Three tiers: [cpu-kernels (extern "C" interface), cuda-kernels (extern "C" interface)],
 # libawkward (C++), and Python modules.
@@ -49,6 +62,18 @@
 # C++ dependencies (header-only): GrowableBuffer
 add_subdirectory(header-only EXCLUDE_FROM_ALL)
 target_link_libraries(awkward-parent INTERFACE awkward::growable-buffer)
+
+# WASM needs exceptions enabled
+if(CMAKE_SYSTEM_NAME MATCHES Emscripten)
+  set_property(
+    TARGET awkward-parent
+    APPEND
+    PROPERTY INTERFACE_LINK_OPTIONS -fexceptions)
+  set_property(
+    TARGET awkward-parent
+    APPEND
+    PROPERTY INTERFACE_COMPILE_OPTIONS -fexceptions)
+endif()
 
 # First tier: cpu-kernels
 add_library(awkward-cpu-kernels SHARED ${CPU_KERNEL_SOURCES})
@@ -97,6 +122,11 @@
              VISIBILITY_INLINES_HIDDEN ON
              CXX_EXTENSIONS NO)
 
+# This has to be passed explicitly to make Pyodide 0.28 happy
+if(CMAKE_SYSTEM_NAME MATCHES Emscripten)
+  target_link_options(_ext PRIVATE "-Wl,-rpath=\$ORIGIN")
+endif()
+
 # Install pure-python files
 file(GLOB_RECURSE PYTHON_SOURCES "src/${SKBUILD_PROJECT_NAME}/*.py")

=== docs/requirements.txt ===
# JupyterLite (kernel requires specific pyodide version)
jupyterlite-pyodide-kernel==0.1.0
jupyterlite[piplite]==0.1.0
jupyterlite-sphinx==0.8.0

sphinx~=7.0
PyYAML
black
pycparser
lark-parser
sphinx-copybutton
sphinx-design
sphinx-sitemap
pydata-sphinx-theme
myst-nb~=1.0
myst-parser~=2.0
sphinx-external-toc
ipyleaflet

numpy
scipy
numba>=0.50.0;python_version<"3.11"
pandas>=0.24.0
numexpr
pyarrow>=7.0.0
fsspec
fsspec-xrootd
hist[plot]
particle
hepunits
vector
scikit-hep-testdata
s3fs
h5py
matplotlib
awkward
uproot
jax>=0.2.7;python_version>="3.6" and sys_platform != "win32"
jaxlib>=0.1.57;python_version>="3.6" and sys_platform != "win32"

=== header-only/CMakeLists.txt ===
# BSD 3-Clause License; see
# https://github.com/scikit-hep/awkward/blob/main/LICENSE

cmake_minimum_required(VERSION 3.15...3.24)

project(
  awkward-headers
  LANGUAGES CXX
  VERSION 1.0.0)

include(GNUInstallDirs)

# Build tests?
option(BUILD_TESTS OFF)

# Add aliases for `add_subdirectory`
set(NAMESPACE "awkward::")

# We want to specify different compile options, so we split the headers into
# "components"
macro(add_component name)
  add_library(${name} INTERFACE)
  add_library(${NAMESPACE}${name} ALIAS ${name})
  target_include_directories(
    ${name} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${name}>
                      $<INSTALL_INTERFACE:include/${name}>)
  target_compile_features(${name} INTERFACE cxx_std_17)

  install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${name}/awkward"
          DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${name}")
endmacro(add_component)

# Component: Builder Options
add_component(builder-options)
# Component: Growable Buffer
add_component(growable-buffer)
target_link_libraries(growable-buffer INTERFACE builder-options)
# Component: Layout Builder
add_component(layout-builder)
target_link_libraries(layout-builder INTERFACE growable-buffer builder-options)

# Build test suite?
if(BUILD_TESTS)
  add_subdirectory(tests)
endif(BUILD_TESTS)

# Installation
install(
  TARGETS layout-builder growable-buffer builder-options
  EXPORT ${PROJECT_NAME}Targets
  INCLUDES
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(
  EXPORT ${PROJECT_NAME}Targets
  FILE ${PROJECT_NAME}Config.cmake
  NAMESPACE ${NAMESPACE}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${PROJECT_NAME}ConfigVersion.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)

=== header-only/tests/CMakeLists.txt ===
# BSD 3-Clause License; see
# https://github.com/scikit-hep/awkward/blob/main/LICENSE

macro(addtest_nolibs name filename)
  add_executable(${name} ${filename})
  set_target_properties(
    ${name}
    PROPERTIES CXX_VISIBILITY_PRESET hidden
               VISIBILITY_INLINES_HIDDEN ON
               CXX_EXTENSIONS NO)
  add_test(${name} ${name})
endmacro(addtest_nolibs)

addtest_nolibs(test_1494-layout-builder test_1494-layout-builder.cpp)
addtest_nolibs(test_1542-growable-buffer test_1542-growable-buffer.cpp)
addtest_nolibs(test_1560-builder-options test_1560-builder-options.cpp)
addtest_nolibs(test_3091-layout-builder-is-valid
               test_3091-layout-builder-is-valid.cpp)

target_link_libraries(test_1494-layout-builder PRIVATE awkward::layout-builder)
target_link_libraries(test_1542-growable-buffer
                      PRIVATE awkward::growable-buffer)
target_link_libraries(test_1560-builder-options
                      PRIVATE awkward::builder-options)
target_link_libraries(test_3091-layout-builder-is-valid
                      PRIVATE awkward::layout-builder)

=== header-only/examples/cython/CMakeLists.txt ===
# BSD 3-Clause License; see
# https://github.com/scikit-hep/awkward/blob/main/LICENSE

cmake_minimum_required(VERSION 3.15...3.26)

project(demo LANGUAGES CXX C)

# Download headers
include(FetchContent)
set(AWKWARD_VERSION "v2.4.3")
FetchContent_Declare(
  awkward-headers
  URL https://github.com/scikit-hep/awkward/releases/download/${AWKWARD_VERSION}/header-only.zip
)
# Instead of using `FetchContent_MakeAvailable(awkward-headers)`, we manually
# load the target so that we can EXCLUDE_FROM_ALL
FetchContent_GetProperties(awkward-headers)
if(NOT awkward-headers_POPULATED)
  FetchContent_Populate(awkward-headers)
  add_subdirectory(${awkward-headers_SOURCE_DIR} ${awkward-headers_BINARY_DIR}
                   EXCLUDE_FROM_ALL)
endif()

find_package(Python REQUIRED COMPONENTS Interpreter Development.Module NumPy)
find_package(Cython REQUIRED)
find_package(PythonExtensions REQUIRED)

# Build demo module
add_cython_target(_demo _demo.pyx PY3 CXX)
add_python_library(
  _demo
  MODULE
  SOURCES
  ${_demo}
  demo_impl.cpp
  LINK_LIBRARIES
  awkward::layout-builder
  Python::NumPy
  INCLUDE_DIRECTORIES
  include)
python_extension_module(_demo)

install(
  TARGETS _demo
  RUNTIME DESTINATION demo
  LIBRARY DESTINATION demo
  ARCHIVE DESTINATION demo)

=== header-only/examples/pybind11/CMakeLists.txt ===
# BSD 3-Clause License; see
# https://github.com/scikit-hep/awkward/blob/main/LICENSE

cmake_minimum_required(VERSION 3.15...3.26)

project(
  ${SKBUILD_PROJECT_NAME}
  LANGUAGES CXX
  VERSION ${SKBUILD_PROJECT_VERSION})

# Download headers
include(FetchContent)
set(AWKWARD_VERSION "v2.4.3")
FetchContent_Declare(
  awkward-headers
  URL https://github.com/scikit-hep/awkward/releases/download/${AWKWARD_VERSION}/header-only.zip
)
# Instead of using `FetchContent_MakeAvailable(awkward-headers)`, we manually
# load the target so that we can EXCLUDE_FROM_ALL
FetchContent_GetProperties(awkward-headers)
if(NOT awkward-headers_POPULATED)
  FetchContent_Populate(awkward-headers)
  add_subdirectory(${awkward-headers_SOURCE_DIR} ${awkward-headers_BINARY_DIR}
                   EXCLUDE_FROM_ALL)
endif()

# Load interpreter & pybind11
find_package(Python COMPONENTS Interpreter Development.Module)
find_package(pybind11 CONFIG)

# Build demo module
pybind11_add_module(demo demo.cpp)
target_link_libraries(demo PRIVATE awkward::layout-builder)

# Install into wheel
install(TARGETS demo DESTINATION .)

=== debian/changelog ===
python-awkward (2.8.9-1) unstable; urgency=medium

  * Package Adoption
  * Updated to version 2.8.9
  * Remove rapidjson license reference in pyproject.toml

 -- Aryan Karamtoth <spaciouscoder78@disroot.org>  Mon, 29 Sep 2025 06:45:57 +0530

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: python-awkward
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Sascha Steinbiss <satta@debian.org>
+Uploaders: Aryan Karamtoth <spaciouscoder78@disroot.org>
 Section: python
 Priority: optional
 Build-Depends: dh-sequence-python3,
@@ -23,7 +23,7 @@
                pybind11-dev,
                rapidjson-dev,
                nox
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/python-awkward
 Vcs-Git: https://salsa.debian.org/med-team/python-awkward.git
 Homepage: https://github.com/scikit-hep/awkward

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_DESTDIR = debian/tmp_i_mean_it
export PYBUILD_TEST_ARGS=-v
export PY_IGNORE_IMPORTMISMATCH=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export NOX_DEFAULT_VENV_BACKEND=none

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean \
override_dh_auto_configure \
override_dh_auto_install: override_%:
	PYBUILD_NAME=awkward_cpp $* --buildsystem=pybuild --sourcedirectory=awkward-cpp
	PYBUILD_NAME=awkward $* --buildsystem=pybuild --sourcedirectory=.

override_dh_auto_build:
	nox -s prepare --no-venv
	PYBUILD_NAME=awkward_cpp dh_auto_build --sourcedirectory=awkward-cpp --buildsystem=pybuild
	PYBUILD_NAME=awkward dh_auto_build --sourcedirectory=. --buildsystem=pybuild

override_dh_install:
	dh_install --sourcedir=debian/tmp_i_mean_it

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_auto_test:
	# pass

=== debian/tests/control ===
Tests: python-test 
Depends: python3-awkward, python3-numpy
Restrictions: allow-stderr, skip-not-installable

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/scikit-hep/awkward/tags (?:.*?/)?v?@ANY_VERSION@\.tar\.gz

## python-awkward 2.8.10

=== debian/changelog ===
python-awkward (2.8.10-2) unstable; urgency=medium

  * Team upload.
  * Fix clean target.
  * Drop "Rules-Requires-Root: no" (default).
  * Drop "Priority: optional" (default).
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sat, 07 Feb 2026 11:50:00 +0100

python-awkward (2.8.10-1) unstable; urgency=medium

  * Updated to version 2.8.10

 -- Aryan Karamtoth <spaciouscoder78@disroot.org>  Sat, 15 Nov 2025 08:45:57 +0530

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Aryan Karamtoth <spaciouscoder78@disroot.org>
 Section: python
-Priority: optional
 Build-Depends: dh-sequence-python3,
                python3-setuptools,
                debhelper-compat (= 13),
@@ -23,11 +22,10 @@
                pybind11-dev,
                rapidjson-dev,
                nox
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/python-awkward
 Vcs-Git: https://salsa.debian.org/med-team/python-awkward.git
 Homepage: https://github.com/scikit-hep/awkward
-Rules-Requires-Root: no
 
 Package: python3-awkward
 Architecture: any

## python-awkward 2.9.0

=== debian/changelog ===
python-awkward (2.9.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.9.0
  * Refresh patches
  * This needs a new version of "nox" >= 2025.2.9

 -- Alexandre Detiste <tchet@debian.org>  Mon, 09 Feb 2026 16:55:36 +0100

=== debian/control ===
Source: python-awkward
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Aryan Karamtoth <spaciouscoder78@disroot.org>,
Section: python
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 cmake,
 libpython3-all-dev,
 nox (>= 2025.2.09~),
 pybind11-dev,
 pybuild-plugin-pyproject,
 python-is-python3,
 python3-all,
 python3-fsspec,
 python3-hatch-fancy-pypi-readme,
 python3-hatchling,
 python3-numpy,
 python3-pyproject-metadata,
 python3-pytest,
 python3-scikit-build-core,
 python3-setuptools,
 python3-typing-extensions,
 python3-yaml,
 rapidjson-dev,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/python-awkward
Vcs-Git: https://salsa.debian.org/med-team/python-awkward.git
Homepage: https://github.com/scikit-hep/awkward

Package: python3-awkward
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: manipulate JSON-like data with NumPy-like idioms
 Awkward Array is a library for nested, variable-sized data, including
 arbitrary-length lists, records, mixed types, and missing data, using
 NumPy-like idioms.
 .
 Arrays are dynamically typed, but operations on them are compiled and fast.
 Their behavior coincides with NumPy when array dimensions are regular and
 generalizes when they're not.

=== debian/tests/control ===
Tests:
 python-test,
Depends:
 python3-awkward,
 python3-numpy,
Restrictions:
 allow-stderr,
 skip-not-installable,
